Attribute VB_Name = "NTSecurity"

'File
Public Declare Function GetFileSecurity Lib "advapi32.dll" Alias "GetFileSecurityA" (ByVal lpFileName As String, ByVal RequestedInformation As Long, pSecurityDescriptor As Any, ByVal nLength As Long, lpnLengthNeeded As Long) As Long
Public Declare Function SetFileSecurity Lib "advapi32.dll" Alias "SetFileSecurityA" (ByVal lpFileName As String, ByVal SecurityInformation As Long, pSecurityDescriptor As SECURITY_DESCRIPTOR) As Long

Public Const OWNER_SECURITY_INFORMATION = 1
Public Const GROUP_SECURITY_INFORMATION = 2
Public Const DACL_SECURITY_INFORMATION = 4
Public Const SACL_SECURITY_INFORMATION = 8

'Security Descriptor
Public Declare Function GetSecurityDescriptorOwner Lib "advapi32.dll" (pSecurityDescriptor As Any, pOwner As Long, lpbOwnerDefaulted&) As Long
Public Declare Function GetSecurityDescriptorGroup Lib "advapi32.dll" (pSecurityDescriptor As Any, pGroup As Long, lpbGroupDefaulted&) As Long
Public Declare Function GetSecurityDescriptorDacl Lib "advapi32.dll" (pSecurityDescriptor As Any, lpbDaclPresent As Long, Dacl As Long, lpbDaclDefaulted&) As Long
Public Declare Function InitializeSecurityDescriptor Lib "advapi32.dll" (pSecurityDescriptor As Any, ByVal dwRevision As Long) As Long
Public Declare Function SetSecurityDescriptorDacl Lib "advapi32.dll" (pSecurityDescriptor As Any, ByVal bDaclPresent As Long, ByVal Dacl As Long, ByVal bDaclDefaulted As Long) As Long

Public Const SECURITY_DESCRIPTOR_REVISION = 1

Type SECURITY_DESCRIPTOR
   Revision As Byte
   Sbz1 As Byte
   Control As Integer
   Owner As Long
   Group As Long
   sacl As Long
   Dacl As Long
End Type

'Sid
Public Declare Function LookupAccountSid Lib "advapi32.dll" Alias "LookupAccountSidA" (lpSystemName As Any, Sid As Any, ByVal name As String, cbName As Long, ByVal ReferencedDomainName As String, cbReferencedDomainName As Long, peUse As Integer) As Long
Public Declare Function LookupAccountName Lib "advapi32.dll" Alias "LookupAccountNameA" (lpSystemName As Any, ByVal lpAccountName As String, Sid As Any, cbSid As Long, ByVal ReferencedDomainName As String, cbReferencedDomainName As Long, peUse As Integer) As Long

'Acl
Public Declare Function InitializeAcl Lib "advapi32.dll" (ByVal pAcl&, ByVal nAclLength&, ByVal dwAclRevision&) As Long
Public Declare Function AddAccessAllowedAce Lib "advapi32.dll" (ByVal pAcl&, ByVal dwAceRevision As Long, ByVal AccessMask As Long, pSid As Any) As Long
Public Declare Function AddAccessDeniedAce Lib "advapi32.dll" (ByVal pAcl&, ByVal dwAceRevision As Long, ByVal AccessMask As Long, pSid As Any) As Long
Public Declare Function GetAce Lib "advapi32.dll" (ByVal pAcl&, ByVal dwAceIndex As Long, pAce As Long) As Long

Public Const ACL_REVISION2 = 2
Public Const ACCESS_ALLOWED_ACE_TYPE = &H0
Public Const ACCESS_DENIED_ACE_TYPE = &H1

Public Const OBJECT_INHERIT_ACE = &H1
Public Const CONTAINER_INHERIT_ACE = &H2
Public Const NO_PROPAGATE_INHERIT_ACE = &H4
Public Const INHERIT_ONLY_ACE = &H8
Public Const SUCCESSFUL_ACCESS_ACE_FLAG = &H40
Public Const FAILED_ACCESS_ACE_FLAG = &H80

Type ACL
   AclRevision As Byte
   Sbz1 As Byte
   AclSize As Integer
   AceCount As Integer
   Sbz2 As Integer
End Type

Public Type ACE_HEADER
   AceType As Byte
   AceFlags As Byte
   AceSize As Integer
   AceMask As Long
End Type

Public Const DELETE = &H10000
Public Const READ_CONTROL = &H20000
Public Const WRITE_DAC = &H40000
Public Const WRITE_OWNER = &H80000
Public Const SYNCHRONIZE = &H100000

Public Const STANDARD_RIGHTS_READ = READ_CONTROL
Public Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Public Const STANDARD_RIGHTS_EXECUTE = READ_CONTROL
Public Const STANDARD_RIGHTS_ALL = &H1F0000

Public Const FILE_READ_DATA = &H1
Public Const FILE_WRITE_DATA = &H2
Public Const FILE_APPEND_DATA = &H4
Public Const FILE_READ_EA = &H8
Public Const FILE_WRITE_EA = &H10
Public Const FILE_EXECUTE = &H20
Public Const FILE_DELETE_CHILD = &H40
Public Const FILE_READ_ATTRIBUTES = &H80
Public Const FILE_WRITE_ATTRIBUTES = &H100

Public Const FILE_GENERIC_READ = STANDARD_RIGHTS_READ Or FILE_READ_DATA Or FILE_READ_ATTRIBUTES Or FILE_READ_EA Or SYNCHRONIZE
Public Const FILE_GENERIC_WRITE = STANDARD_RIGHTS_WRITE Or FILE_WRITE_DATA Or FILE_WRITE_ATTRIBUTES Or FILE_WRITE_EA Or FILE_APPEND_DATA Or SYNCHRONIZE
Public Const FILE_GENERIC_EXECUTE = STANDARD_RIGHTS_EXECUTE Or FILE_READ_ATTRIBUTES Or FILE_EXECUTE Or SYNCHRONIZE
Public Const FILE_ALL_ACCESS = STANDARD_RIGHTS_ALL Or &H1FF

'Memory
Public Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Sub HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal lpMem&)
Public Declare Sub MemoryCopy Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal dwBytes As Long)
Public Declare Function GetProcessHeap Lib "kernel32" () As Long

Function GetOwner$(file$)

GetOwner$ = ""

R& = GetFileSecurity(file$, OWNER_SECURITY_INFORMATION, ByVal 0, 0, Size&)
sdadr& = HeapAlloc(GetProcessHeap(), 0, Size&): If sdadr& = 0 Then Exit Function
R& = GetFileSecurity(file$, OWNER_SECURITY_INFORMATION, ByVal sdadr&, Size&, s&)

R& = GetSecurityDescriptorOwner(ByVal sdadr&, sidadr&, r1&)
If sidadr& Then GetOwner$ = Sid2String$(sidadr&)

HeapFree GetProcessHeap(), 0, sdadr&

End Function

Function GetGroup$(file$)

GetGroup$ = ""

R& = GetFileSecurity(file$, GROUP_SECURITY_INFORMATION, ByVal 0, 0, Size&)
sdadr& = HeapAlloc(GetProcessHeap(), 0, Size&): If sdadr& = 0 Then Exit Function
R& = GetFileSecurity(file$, GROUP_SECURITY_INFORMATION, ByVal sdadr&, Size&, s&)

L& = GetSecurityDescriptorGroup(ByVal sdadr&, sidadr&, r1&)
If sidadr& Then GetGroup$ = Sid2String$(sidadr&)

HeapFree GetProcessHeap(), 0, sdadr&

End Function

Function parse$(a$, ch$)

ai% = InStr(a$, ch$)
If ai% = 0 Then
  parse$ = a$: a$ = ""
Else
  parse$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If

End Function

Function Sid2String$(ByVal sidadr&)

anz1& = 200: a1$ = Space$(200): anz2& = 200: a2$ = Space$(200): peUse% = 0
R& = LookupAccountSid(ByVal 0, ByVal sidadr&, a1$, anz1&, a2$, anz2&, peUse%)
If R& Then Sid2String$ = Left$(a1$, InStr(a1$, Chr$(0)) - 1) Else Sid2String$ = ""

End Function

Function FormatRights$(mask&)

a$ = ""

If (mask& And FILE_GENERIC_READ) = FILE_GENERIC_READ Then a$ = a$ + "R"
If (mask& And FILE_GENERIC_WRITE) = FILE_GENERIC_WRITE Then a$ = a$ + "W"
If (mask& And FILE_GENERIC_EXECUTE) = FILE_GENERIC_EXECUTE Then a$ = a$ + "X"
If (mask& And DELETE) = DELETE Then a$ = a$ + "D"
If (mask& And WRITE_DAC) = WRITE_DAC Then a$ = a$ + "P"
If (mask& And WRITE_OWNER) = WRITE_OWNER Then a$ = a$ + "O"

If (mask& And FILE_ALL_ACCESS) = FILE_ALL_ACCESS Then a$ = "Alle"
If a$ = "RX" Then a$ = "Lesen (RX)"
If a$ = "RWXD" Then a$ = "ndern (RWXD)"
If a$ = "" Then a$ = "kein Zugriff"

FormatRights$ = a$

End Function

Function SetRights&(ByVal rechte$)

mask& = 0

rechte$ = LCase$(rechte$)
If rechte$ = "kein zugriff" Then rechte$ = ""
If rechte$ = "lesen" Then rechte$ = "rx"
If rechte$ = "ndern" Then rechte$ = "rwxd"
   
If rechte$ = "alle" Then
   mask& = FILE_ALL_ACCESS
Else
   If InStr(rechte$, "r") Then mask& = mask& Or FILE_GENERIC_READ
   If InStr(rechte$, "w") Then mask& = mask& Or FILE_GENERIC_WRITE
   If InStr(rechte$, "x") Then mask& = mask& Or FILE_GENERIC_EXECUTE
   If InStr(rechte$, "d") Then mask& = mask& Or DELETE
   If InStr(rechte$, "p") Then mask& = mask& Or WRITE_DAC
   If InStr(rechte$, "o") Then mask& = mask& Or WRITE_OWNER
End If

SetRights& = mask&

End Function

Function GetAcl$(file$)

GetAcl$ = ""
ret$ = ""

Size& = 0
R& = GetFileSecurity(file$, DACL_SECURITY_INFORMATION, ByVal 0, 0, Size&): If Size& = 0 Then Exit Function
sdadr& = HeapAlloc(GetProcessHeap(), 0, Size&): If sdadr& = 0 Then Exit Function
R& = GetFileSecurity(file$, DACL_SECURITY_INFORMATION, ByVal sdadr&, Size&, s&): If R& = 0 Then GoTo GetAcl_Error

R& = GetSecurityDescriptorDacl(ByVal sdadr&, r1&, acladr&, r2&)

Dim Dacl As ACL
MemoryCopy Dacl, ByVal acladr&, Len(Dacl)

For n% = 1 To Dacl.AceCount
   R& = GetAce(acladr&, n% - 1, aceadr&)
   
   Dim ace As ACE_HEADER
   MemoryCopy ace, ByVal aceadr&, Len(ace)
   
   If ace.AceType = ACCESS_ALLOWED_ACE_TYPE Then vor$ = "" Else vor$ = "-"
   sidadr& = aceadr& + Len(ace)
   ret$ = ret$ + ", " + Sid2String$(sidadr&) + ": " + vor$ + FormatRights$(ace.AceMask)
   If ace.AceFlags Then ret$ = ret$ & " [" & ace.AceFlags & "]"
Next

GetAcl_Error:
HeapFree GetProcessHeap(), 0, sdadr&
GetAcl$ = Mid$(ret$, 3)

End Function

Sub SetAcl(file$, aclist$)

acladr& = 0: pos% = 0: aclist$ = Trim$(aclist$)
If Len(aclist$) Then
   Size& = 10000
   acladr& = HeapAlloc(GetProcessHeap(), 0, Size&)
   R& = InitializeAcl(acladr&, Size&, ACL_REVISION2): If R& = 0 Then GoTo SetAcl_Error

   Do While Len(aclist$)
      acentry$ = Trim$(parse$(aclist$, ",")): aclist$ = Trim$(aclist$)
      user$ = Trim$(parse$(acentry$, ":")): acentry$ = Trim$(acentry$)
      rechte$ = Trim$(parse$(acentry$, "[")): acentry$ = Trim$(acentry$)
      flag% = Val(parse$(acentry$, "]"))
      
      deny% = (Left$(rechte$, 1) = "-"): If deny% Then rechte$ = Trim$(Mid$(rechte$, 2))
      If InStr(rechte$, "(") Then rechte$ = Trim$(parse$(Mid$(rechte$, InStr(rechte$, "(") + 1), ")"))
      
      'SID bestimmen
      Size& = 1024
      sidadr& = HeapAlloc(GetProcessHeap(), 0, Size&)
      anz1& = 200: a1$ = Space$(200): peUse% = 0
      R& = LookupAccountName(ByVal 0, user$, ByVal sidadr&, Size&, a1$, anz1&, peUse%)
      
      'ACE erweitern
      If R& = 0 Then
         MsgBox "User/Gruppe " + user$ + " nicht definiert", 48, "Set ACL"
      ElseIf deny% = False Then
         R& = AddAccessAllowedAce(acladr&, ACL_REVISION2, SetRights&(rechte$), ByVal sidadr&)
      Else
         R& = AddAccessDeniedAce(acladr&, ACL_REVISION2, SetRights&(rechte$), ByVal sidadr&)
      End If
      
      'Flag nachtrglich setzen
      If R& Then
         pos% = pos% + 1
         
         Dim ace As ACE_HEADER
         R& = GetAce(acladr&, pos% - 1, aceadr&)
         MemoryCopy ace, ByVal aceadr&, Len(ace)
         ace.AceFlags = flag%
         MemoryCopy ByVal aceadr&, ace, Len(ace)
      End If
      
      HeapFree GetProcessHeap(), 0, sidadr&
   Loop
End If

Dim s As SECURITY_DESCRIPTOR
R& = InitializeSecurityDescriptor(s, SECURITY_DESCRIPTOR_REVISION): If R& = 0 Then GoTo SetAcl_Error
R& = SetSecurityDescriptorDacl(s, True, acladr&, False): If R& = 0 Then GoTo SetAcl_Error
R& = SetFileSecurity(file$, DACL_SECURITY_INFORMATION, s)
If R& = 0 Then MsgBox "Die ACL kann nicht gesetzt werden.", 16, "Set ACL"

SetAcl_Error:
If acladr& Then HeapFree GetProcessHeap(), 0, acladr&
   
End Sub
